
import string, Acquisition

from Globals import HTMLFile, MessageDialog, INSTANCE_HOME
from OFS.Folder import Folder

import sys

if sys.version[:5] == '1.5.2' :
	import re
else:
	import re

from Products.zExtraExAuths.ExternalBase.ExternalBase import ExternalBase
from Products.exUserFolder.exUserFolder import exUserFolder
from Products.exUserFolder.Plugins import PluginRegister

def manage_addPOP3AuthSource(self, REQUEST):

    """ """
    host=REQUEST['host']
    port=REQUEST['port']
    try:
        cache_time=REQUEST['cache_time']
    except:
        cache_time=600
    ob=POP3Adapter(id='POP3AuthSource', host=host, port=port, cache_time=cache_time)
    self._setObject('POP3AuthSource', ob)
    self.currentAuthSource=ob

manage_editPOP3AuthSourceForm=HTMLFile('manage_editPOP3AuthSourceForm', globals())
manage_addPOP3AuthSourceForm=HTMLFile('manage_addPOP3AuthSourceForm', globals())
    
class POP3Adapter(ExternalBase):
	### These stuff define what this connection waits for. They are all regexs ###
	# [Subgroup that has the bit, leftovers, regex]
	connectstart = [0, 1, re.compile(".*?\+OK(.*)", re.DOTALL)]
	sendusername = [0, 1, re.compile("(.*)", re.DOTALL)]
	sendpassword = [0, 1, re.compile(".*?\+OK.*?password(.*)", re.DOTALL)]
	passwordok =   [0, 1, re.compile(".*?\+OK(.*)", re.DOTALL)]
	passwordnotokay = [0, 1, re.compile(".*?-ERR(.*)", re.DOTALL)]
	okaytosendagain = [0, 1, re.compile("(.*)", re.DOTALL)]
	error = [0, 1, re.compile(".*?-ERR(.*)", re.DOTALL)]
	
	### These stuff to send %U is replaced with the username %P with the password
	username = "USER %s\n"
	password = "PASS %s\n"
	after = "QUIT"

	per = 0

	manage_editForm = manage_editPOP3AuthSourceForm

POP3AuthReg=PluginRegister('POP3AuthSource', 'POP3 Authentication source',
						 POP3Adapter, manage_addPOP3AuthSourceForm,
						 manage_addPOP3AuthSource,
						 manage_editPOP3AuthSourceForm, None)
exUserFolder.authSources['POP3AuthSource']=POP3AuthReg

