
import string, Acquisition

from Globals import HTMLFile, MessageDialog, INSTANCE_HOME

from OFS.Folder import Folder

from Products.exUserFolder.exUserFolder import exUserFolder
from Products.exUserFolder.Plugins import PluginRegister

import sys

if sys.version[:5] == '1.5.2' :
	import re
else:
	import re

from Products.zExtraExAuths.ExternalBase.ExternalBase import ExternalBase


def manage_addIMAPAuthSource(self, REQUEST):

    """ """
    host=REQUEST['host']
    port=REQUEST['port']
    cache_time=REQUEST['cache_time']
    time_out=REQUEST['time_out']
    ob=IMAPAdapter(id='IMAPAuthSource', host=host, port=port, cache_time=cache_time, time_out=time_out)
    self._setObject('IMAPAuthSource', ob)
    self.currentAuthSource=ob

manage_editIMAPAuthSourceForm=HTMLFile('manage_editIMAPAuthSourceForm', globals())
manage_addIMAPAuthSourceForm=HTMLFile('manage_addIMAPAuthSourceForm', globals())

class IMAPAdapter(ExternalBase):
	### These stuff define what this connection waits for. They are all regexs ###
	# [Subgroup that has the bit, leftovers, regex]
	connectstart = [0, 2, re.compile("(.*?)OK(.*)", re.DOTALL)]
	sendusername = [0, 1, re.compile("(.*)", re.DOTALL)]
	sendpassword = [0, 1, re.compile("(.*)", re.DOTALL)]
	passwordok =   [0, 2, re.compile("(.*?)OK LOGIN completed(.*)", re.DOTALL)]
	passwordnotokay = [0, 2, re.compile("(.*?)NO LOGIN failed(.*)", re.DOTALL)]
	okaytosendagain = [0, 1, re.compile("(.*)", re.DOTALL)]
	error = [0, 1, re.compile("(.*)BAD(.*)", re.DOTALL)]
	
	### These stuff to send %U is replaced with the username %P with the password
	username = "220 LOGIN %s"
	password = " %s\n"
	after = "222 LOGOUT"

	per = 0

	manage_editForm = manage_editIMAPAuthSourceForm

IMAPAuthReg=PluginRegister('IMAPAuthSource', 'IMAP Authentication source',
						 IMAPAdapter, manage_addIMAPAuthSourceForm,
						 manage_addIMAPAuthSource,
						 manage_editIMAPAuthSourceForm, None)
exUserFolder.authSources['IMAPAuthSource']=IMAPAuthReg
